# <pvcsput>

Puts files into a PVCS repository.

This task uses the `put` PCLI command to put the files into PVCS.

### Parameters

Attribute | Type | Description | Required
--- | --- | --- | ---
description | string | Gets or sets the description to be applied to the checked in revisions. | True
baseprojectpath | string | Gets or sets the base project path. | False
checkinunchanged | bool | Gets or sets a value indicating whether unchanged workfiles should be checked in. | False
floatlabel | bool | Gets or sets a value indicating whether the version label specified by `versionlabel` should float. | False
forcebranch | bool | Gets or sets a value indicating whether a new branch will be created. | False
ignorespaces | bool | Gets or sets a value indicating whether leading and trailing spaces should be ignored when determining whether the revision has changed. | False
keepworkfile | bool | Gets or sets a value indicating whether the workfile should kept in its original state. | False
location | string | Gets or sets an alternative location for workfiles. | False
lock | bool | Gets or sets a value indicating the files should be locked after the put operation. | False
overrideworkfilelocation | bool | Gets or sets a value indicating whether the workfile location for files should be overridden. | False
promotiongroup | string | Gets or sets the promotion in use. If a promotion group is specified, this option identifies the promotion group to which the revision is currently assigned. If no promotion group is specified (ie. this property is set to an empty string), this option indicates that one is not identifying the revision by promotion group. | False
reassignlabelifexists | bool | Gets or sets a value indicating whether the version label specified by `versionlabel` should be reassigned if it already exists. | False
revision | double | Gets or sets the revision number to use for the new revision. | False
usesamedescription | bool | Gets or sets a value indicating whether the same description should be used for all versioned items. This is `true` by default. | False
versionlabel | string | Gets or sets the version label to assign to the new revisions. | False
projectdatabase | string | Gets or sets the project database to utilize during the operation. | True
failonerror | bool | Determines if task failure stops the build, or is just reported. The default is true. | False
if | bool | If true then the task will be executed; otherwise, skipped. The default is true. | False
includesubprojects | bool | Gets or sets a value indicating whether the operation should include subprojects. | False
password | string | Gets or sets the password to use when connecting to the project database. | False
projectpath | string | Gets or sets the project path to utilize during the operation. | False
pvcsbin | string | Gets or sets the location of the PVCS binary command-line tools. | False
timeout | int | The maximum amount of time the application is allowed to execute, expressed in milliseconds. Defaults to no time-out. | False
unless | bool | Opposite of `if`. If false then the task will be executed; otherwise, skipped. The default is false. | False
userid | string | Gets or sets the user ID to use when connecting to the project database. | False
verbose | bool | Determines whether the task should report detailed build log messages. The default is false. | False
workspace | string | Gets or sets the workspace to use when connecting to the project database. | False

### Framework-configurable parameters

Attribute | Type | Description | Required
--- | --- | --- | ---
managed | ManagedExecution | Specifies whether the external program should be treated as a managed application, possibly forcing it to be executed under the currently targeted version of the CLR. | False
useruntimeengine | bool | Deprecated. Specifies whether the external program is a managed application which should be executed using a runtime engine, if configured. The default is false. | False

### Nested Elements:

#### <entities>

Gets or sets the entities involved in the operation.

#### </entities>

#### <arg>

The command-line arguments for the external program.

Represents a command-line argument.

When passed to an external application, the argument will be quoted when appropriate. This does not apply to the `line` parameter, which is always passed as is.

### Parameters

Attribute | Type | Description | Required
--- | --- | --- | ---
dir | directory | The value for a directory-based command-line argument; will be replaced with the absolute path of the directory. | False
file | file | The name of a file as a single command-line argument; will be replaced with the absolute filename of the file. | False
if | bool | Indicates if the argument should be passed to the external program. If true then the argument will be passed; otherwise, skipped. The default is true. | False
line | string | List of command-line arguments; will be passed to the executable as is. | False
path | <path> | The value for a PATH-like command-line argument; you can use `:` or `;` as path separators and NAnt will convert it to the platform's local conventions, while resolving references to environment variables. | False
unless | bool | Indicates if the argument should not be passed to the external program. If false then the argument will be passed; otherwise, skipped. The default is false. | False
value | string | A single command-line argument; can contain space characters. | False

### Nested Elements:

#### <path>

Sets a single command-line argument and treats it like a PATH - ensures the right separator for the local platform is used.

#### </path>

### Examples

- A single command-line argument containing a space character.

      <arg value="-l -a" />

- Two separate command-line arguments.

      <arg line="-l -a" />

- A single command-line argument with the value `\dir;\dir2;\dir3` on DOS-based systems and `/dir:/dir2:/dir3` on Unix-like systems.

      <arg path="/dir;/dir2:\dir3" />

#### </arg>

### Examples

- Puts the file called `App.ico` into the project database specified by the `project-database` property. The description for the change is `Added more colour`.

                  <pvcsput projectdatabase="${project-database}" description="Added more colour">
                      <entities>
                          <entity name="/App.ico"/>
                      </entities>
                  </pvcsput>

- Puts all files into the project database specified by the `project-database` property. The description for the changes is `Major changes`. Even if the workfiles have not been changed, they will result in a new revision in PVCS.

                  <pvcsput projectdatabase="${project-database}" description="Major changes" checkinunchanged="true" includesubprojects="true">
                      <entities>
                          <entity name="/"/>
                      </entities>
                  </pvcsput>

- Puts `file.txt` and all files in `folder` into the project database specified by the `project-database` property. The description for the changes is `Some changes`. A new branch is forcibly created via the `forcebranch` attribute. Leading and trailing whitespace is ignored when determining whether the workfile has been altered.

                  <pvcsput projectdatabase="${project-database}" description="Some changes" forcebranch="true" ignorespaces="true">
                      <entities>
                          <entity name="/folder"/>
                          <entity name="/file.txt"/>
                      </entities>
                  </pvcsput>

### Requirements

Assembly: NAnt.Contrib.Tasks (0.91.4312.0)